/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 141
#ifdef HAVE_CONFIG_H
#line 141
# include <config.h>
#line 141
#endif
#line 141
#include <sys/types.h>
#line 141

#line 141
#include "mailfromd.h"
#line 141
#include "prog.h"
#line 141
#include "builtin.h"
#line 141

#line 47 "other.bi"
static size_t debug_handle;
#line 141 "other.bi"

#line 660 "../../src/builtin/snarf.m4"

#line 1 "other.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

static int
valid_user_p(eval_environ_t env, const char *name)
{
	int rc;
	struct mu_auth_data *auth_data = NULL;

	rc = mu_get_auth(&auth_data, mu_auth_key_name, name);
	mu_auth_data_free(auth_data);
	switch (rc) {
	case 0:
		rc = 1;
		break;
		
	case MU_ERR_AUTH_FAILURE:
		rc = 0;
		break;

	case EAGAIN:
                	env_throw_bi(env, mfe_temp_failure, NULL, _("temporary failure querying for username %s"),name);
#line 38
		break;

	default:
                	env_throw_bi(env, mfe_failure, NULL, _("failure querying for username %s"),name);
#line 44
		break;
	}

	
#line 47 "other.bi"

#line 47
mu_debug(debug_handle, 10,("Checking user %s: %s", name, rc ? "true" : "false"));
#line 49
	return rc;
}

void
#line 52
bi_validuser(eval_environ_t env)
#line 52

#line 52 "other.bi"
{
#line 52
	
#line 52

#line 52

#line 52
char * name;
#line 52
        
#line 52
get_string_arg(env, 0, &name);
#line 52
        
#line 52

#line 52
        adjust_stack(env, 1);
#line 52

#line 52
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 52
		prog_trace(env, "validuser %s",name);;
#line 52

{
	
#line 54
do {
#line 54
  push(env, (STKVAL) (valid_user_p(env, name)));
#line 54
  return;
#line 54
} while (0);
}
}

void
#line 58
bi_interval(eval_environ_t env)
#line 58

#line 58 "other.bi"
{
#line 58
	
#line 58

#line 58

#line 58
char * str;
#line 58
        
#line 58
get_string_arg(env, 0, &str);
#line 58
        
#line 58

#line 58
        adjust_stack(env, 1);
#line 58

#line 58
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 58
		prog_trace(env, "interval %s",str);;
#line 58

{
       time_t t;
       const char *endp;

       	if (!(parse_time_interval(str, &t, &endp) == 0))
#line 63
			env_throw_bi(env, mfe_invtime, "interval", _("unrecognized time format (near `%s')"),endp)
#line 65
;
       
#line 66
do {
#line 66
  push(env, (STKVAL) (t));
#line 66
  return;
#line 66
} while (0);
}
}

void
#line 70
bi_debug_level(eval_environ_t env)
#line 70

#line 70 "other.bi"
{
#line 70
	
#line 70

#line 70
long __bi_argcnt;
#line 70
char * modname;
#line 70
        
#line 70
get_string_arg(env, 1, &modname);
#line 70
        
#line 70
get_numeric_arg(env, 0, &__bi_argcnt);
#line 70
        adjust_stack(env, __bi_argcnt + 1);
#line 70

#line 70
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 70
		prog_trace(env, "debug_level %s",((__bi_argcnt > 0) ? modname : ""));;
#line 70

{
	int level;
	char *name = ((__bi_argcnt > 0) ? modname : NULL);
	size_t len = name ? 0 : strlen (name);
	
		if (!(mu_debug_category_level(name, len, &level) == 0))
#line 76
			env_throw_bi(env, mfe_range, "debug_level", _("invalid module name: %s"),name)
#line 78
;
	
#line 79
do {
#line 79
  push(env, (STKVAL) (level));
#line 79
  return;
#line 79
} while (0);
}
}

/* FIXME: minlevel is no longer used */
void
#line 84
bi_debug_spec(eval_environ_t env)
#line 84

#line 84 "other.bi"
{
#line 84
	
#line 84

#line 84
long __bi_argcnt;
#line 84
char * modnames;
#line 84
        long  minlevel;
#line 84
        long  showunset;
#line 84
        
#line 84
get_string_arg(env, 1, &modnames);
#line 84
        get_numeric_arg(env, 2, &minlevel);
#line 84
        get_numeric_arg(env, 3, &showunset);
#line 84
        
#line 84
get_numeric_arg(env, 0, &__bi_argcnt);
#line 84
        adjust_stack(env, __bi_argcnt + 1);
#line 84

#line 84
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 84
		prog_trace(env, "debug_spec %s %lu %lu",((__bi_argcnt > 0) ? modnames : ""), ((__bi_argcnt > 1) ? minlevel : 0), ((__bi_argcnt > 2) ? showunset : 0));;

{
	mu_stream_t str;
	size_t off;
	int rc;
	
	rc = mu_memory_stream_create(&str, MU_STREAM_RDWR);
		if (!(rc == 0))
#line 92
			env_throw_bi(env, mfe_failure, "debug_spec", "cannot create stream: %s",mu_strerror(rc))
#line 94
;
	rc = mu_debug_format_spec(str, ((__bi_argcnt > 0) ? modnames : NULL),
				  ((__bi_argcnt > 2) ? showunset : 0));
	if (rc == 0) {
		mu_off_t size;
		char *s;
		size_t n;
		
		mu_stream_seek(str, 0, MU_SEEK_SET, NULL);
		mu_stream_size(str, &size);
		s = (char*) env_data_ref(env, (off = heap_reserve(env, size + 1)));
		rc = mu_stream_read(str, s, size, &n);
		s[n] = 0;
	}
	
	mu_stream_destroy(&str);
		if (!(rc == 0))
#line 110
			env_throw_bi(env, mfe_failure, "debug_spec", "%s",mu_strerror(rc))
#line 112
;
	
#line 113
do {
#line 113
  push(env, (STKVAL) (off));
#line 113
  return;
#line 113
} while (0);
}
}

void
#line 117
bi_debug(eval_environ_t env)
#line 117

#line 117 "other.bi"
{
#line 117
	
#line 117

#line 117

#line 117
char * spec;
#line 117
        
#line 117
get_string_arg(env, 0, &spec);
#line 117
        
#line 117

#line 117
        adjust_stack(env, 1);
#line 117

#line 117
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 117
		prog_trace(env, "debug %s",spec);;
#line 117

{
	mu_debug_parse_spec(spec);
}
}

void
#line 123
bi_program_trace(eval_environ_t env)
#line 123

#line 123 "other.bi"
{
#line 123
	
#line 123

#line 123

#line 123
char * name;
#line 123
        
#line 123
get_string_arg(env, 0, &name);
#line 123
        
#line 123

#line 123
        adjust_stack(env, 1);
#line 123

#line 123
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 123
		prog_trace(env, "program_trace %s",name);;
#line 123

{
	enable_prog_trace(name);
}
}

void
#line 129
bi_cancel_program_trace(eval_environ_t env)
#line 129

#line 129 "other.bi"
{
#line 129
	
#line 129

#line 129

#line 129
char * name;
#line 129
        
#line 129
get_string_arg(env, 0, &name);
#line 129
        
#line 129

#line 129
        adjust_stack(env, 1);
#line 129

#line 129
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 129
		prog_trace(env, "cancel_program_trace %s",name);;
#line 129

{
	disable_prog_trace(name);
}
}	

void
#line 135
bi_stack_trace(eval_environ_t env)
#line 135

#line 135 "other.bi"
{
#line 135
	
#line 135

#line 135

#line 135

#line 135

#line 135

#line 135
        adjust_stack(env, 0);
#line 135

#line 135
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 135
		prog_trace(env, "stack_trace");;
#line 135

{
	runtime_stack_trace(env);
}
}


#line 141
void
#line 141
other_init_builtin()
#line 141
{
#line 141
		debug_handle = mu_debug_register_category("bi_other");
#line 141

#line 141
	#line 52 "other.bi"
va_builtin_install_ex("validuser", bi_validuser, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 58 "other.bi"
va_builtin_install_ex("interval", bi_interval, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 70 "other.bi"
va_builtin_install_ex("debug_level", bi_debug_level, 0, dtype_number, 1, 1, 0|0, dtype_string);
#line 84 "other.bi"
va_builtin_install_ex("debug_spec", bi_debug_spec, 0, dtype_string, 3, 3, 0|0, dtype_string, dtype_number, dtype_number);
#line 117 "other.bi"
va_builtin_install_ex("debug", bi_debug, 0, dtype_unspecified, 1, 0, 0|0, dtype_string);
#line 123 "other.bi"
va_builtin_install_ex("program_trace", bi_program_trace, 0, dtype_unspecified, 1, 0, 0|0, dtype_string);
#line 129 "other.bi"
va_builtin_install_ex("cancel_program_trace", bi_cancel_program_trace, 0, dtype_unspecified, 1, 0, 0|0, dtype_string);
#line 135 "other.bi"
va_builtin_install_ex("stack_trace", bi_stack_trace, 0, dtype_unspecified, 0, 0, 0|0, dtype_unspecified);

#line 141 "other.bi"
	
#line 141
}
#line 141 "other.bi"

#line 141

#line 654 "../../src/builtin/snarf.m4"

#line 654

